
function do_post_request(url,headers,params_in,success_callback,error_callback,do_show_loader=true,id_name_for_div_content=null)
{
    var params = "" ;
    
    if(do_show_loader) show_modal('loader') ;
    
    var http = new XMLHttpRequest();
    http.open("POST", url, true);
    
    for(var key in headers)
    {
        if(headers.hasOwnProperty(key))
        {
            http.setRequestHeader(key,headers[key]);
        }
    }
    
    for(var key in params_in)
    {
        if(params_in.hasOwnProperty(key))
        {
            if(params.length > 0)
            {
                params = params + "&" + key + "=" + params_in[key] ;
            }
            else
            {
                params = key + "=" + params_in[key] ;
            }
        }
    }

    //alert(params);

    http.onload = function()
                  {
                    if(http.readyState == 4)
                    {   
                        if(http.status == 200)
                        {
                            var response = JSON.parse(urlsafe_b64decode(http.responseText)) ;
                            
                            if((response != null) && (typeof response == "object"))
                            {
                                if(response.hasOwnProperty('data')) response['data'] = JSON.parse(urlsafe_b64decode(response['data'])) ;
                            }
                            
                            window[success_callback](response,id_name_for_div_content,params_in) ;
                            if(do_show_loader) hide_modal('loader') ;
                        }
                        else
                        {
                            window[error_callback](http.status,id_name_for_div_content,params_in) ;
                            if(do_show_loader) hide_modal('loader') ;
                        }
                    }
                  }
    //alert(params);
    http.send(params);
}

function check_login(web_api_session_data_l,web_api_session_id_expire_l)
{
    var result = false ;
    
    if((web_api_session_data == web_api_session_data_l) && (web_api_session_id_expire == web_api_session_id_expire_l))
    {
        var d = new Date() ;
        var t = d.getTime() ;
        t = t / 1000 ;
        t = Math.round(t) ;

        if(web_api_session_id_expire > t) result = true ;
    }

    return result ;
}

function send_api_command(command,params_in=null,id_name_for_div_content=null,do_show_loader=true)
{
    var headers = null ;
    var params = null ;
    headers = new Object() ;
    headers['Content-type'] = 'application/x-www-form-urlencoded' ;

    var check_form = true ;
    
    if((typeof(api_functions) == 'object') && (api_functions != null) && api_functions.hasOwnProperty(command) && api_functions[command].hasOwnProperty('result_data') && api_functions[command]['result_data'].hasOwnProperty('type') && (api_functions[command]['result_data']['type'] == 'list')) check_form = false ;
    
    if(typeof web_api_session_data == "string")
    {
        if(web_api_session_data.length > 0)
        {
            var ot_tmp = typeof web_api_session_id_expire ;
            
            if(!isNaN(web_api_session_id_expire))
            {
                var d = new Date() ;
                var t = d.getTime() ;
                t = t / 1000 ;
                t = Math.round(t) ;
                
                if(web_api_session_id_expire > t)
                {
                    headers['web_api_session_data'] = web_api_session_data ;
                    headers['web_api_session_id_expire'] = web_api_session_id_expire ;
                }
            }
        }
    }
    
    //var headers_json = JSON.stringify(headers,null,9) ;
    //alert(headers_json + '\n\n');

    if(typeof params_in == "object")
    {
        params = params_in ;
    }
    else
    {
        params = new Object() ;
    }

    var params_out = new Object() ;
    
    var success_callback = "api_data_receive_ok" ;
    var error_callback = "api_data_receive_error" ;

    //alert(JSON.stringify(params,null,9) + '\n\n') ;

    if((command == 'forgot_password') || (command == 'sign_up') || (command == 'get_api_public_functions'))
    {
        if(!params.hasOwnProperty['lang'])
        {
            var rec_commands = get_get_inputs(false) ;
            if(rec_commands.hasOwnProperty('lang') && (typeof(rec_commands['lang']) == 'string') && (rec_commands['lang'].length > 0))
            {
                params['lang'] = rec_commands['lang'] ;
                //alert('L: ' + params['lang']) ;
            }
            else
            {
                params['lang'] = get_Browser_lang() ;
                //alert('L: ' + params['lang']) ;
            }
        }
    }
    else if(command == 'get_api_functions')
    {
        if(!check_login(web_api_session_data,web_api_session_id_expire))
        {
            if(!params.hasOwnProperty['lang']) params['lang'] = get_Browser_lang() ;
        }
    }

    //alert(JSON.stringify(params,null,9) + '\n\n') ;
    
    params_out['command'] = command ;
    params_out['command_args'] = urlsafe_b64encode(JSON.stringify(params)) ;
    
    switch(command)
    {
        case "get_api_functions":
            success_callback = "api_data_receive_api_functions_ok" ;
            error_callback = "api_data_receive_error" ;
        break ;

        case "get_api_public_functions":
            success_callback = "api_data_receive_api_public_functions_ok" ;
            error_callback = "api_data_receive_error" ;
        break ;

        default:
            success_callback = "api_data_receive_ok" ;
            error_callback = "api_data_receive_error" ;
        break ;
    }

    if(check_form && validate_form_local('api_command_form'))
    {
        //document.getElementById('api_command_form').reset();
        do_post_request(api_end_point,headers,params_out,success_callback,error_callback,do_show_loader,id_name_for_div_content) ;
    }
    else
    {
        do_post_request(api_end_point,headers,params_out,success_callback,error_callback,do_show_loader,id_name_for_div_content) ;
        //enable_all_buttons();
    }
}

function send_api_command_aux(command,params_in=null,id_name_for_div_content_in=null,do_show_loader=true)
{
    var params = null ;

    if(manage_vps_cancel) return true ;

    var id_name_for_div_content = id_name_for_div_content_in ;

    if((params_in != null) && (typeof(params_in) == 'string') && (params_in.length > 0))
    {
        params = JSON.parse( urlsafe_b64decode(params_in)) ;
    }

    send_api_command(command,params,id_name_for_div_content,do_show_loader) ;

    return result ;
}

function validate_form_local(form_id)
{
    var result = false ;
    var id_form = document.getElementById(form_id) ;

    //var elems_in = id_form.getElementsByTagName("INPUT") ;
    var elems_in = id_form.querySelectorAll(form_input_types) ;
    
    if(typeof elems_in == "object")
    {
        for(var key in elems_in)
        {
            if(elems_in.hasOwnProperty(key))
            {
                var elem_in = elems_in[key] ;
                elem_in.setCustomValidity("") ;
            }
        }
    }
    
    if(id_form.checkValidity())
    {
        result = true ;
    }
    
    return result ;
}

function show_login_data_mgnt(get_credentials_defs)
{
    var login_screen_data = get_login_screen(get_credentials_defs) ;
    var login_screen_footer = get_login_screen_footer() ;

    set_login_data('modal_login',login_screen_data,login_screen_footer) ;
    show_modal('login',true) ;
}

function api_data_receive_api_functions_ok(data_in,id_name_for_div_content_in,params_in=null)
{
    var data = data_in ;
    
    if(typeof data == "object")
    {
        if(data.hasOwnProperty('error') && data['error'])
        {
            if(data.hasOwnProperty('errors'))
            {
                var errors = data['errors'] ;
                var err_msg = "<br/>\n" ;
                for(var key in errors)
                {
                    if(errors.hasOwnProperty(key))
                    {
                        var errors_key = errors[key] ;
                        if((typeof(show_error_codes) == 'object') && (show_error_codes != null) && show_error_codes.hasOwnProperty(errors_key))
                        {
                            err_msg = err_msg + show_error_codes[errors_key] + "<br/>\n" ;
                        }
                        else
                        {
                            err_msg = err_msg + errors_key + "<br/>\n" ;
                        }
                    }
                }
                
                err_msg = err_msg + "<br/>\n" ;
                show_alert_data(err_msg,'alert_error') ;
            }
        }
        else if(data.hasOwnProperty('result') && data['result'] && data.hasOwnProperty('data'))
        {
            if(data['data'].hasOwnProperty('show_messages')) show_messages = set_show_messages(data['data']['show_messages']) ;
            if(data['data'].hasOwnProperty('show_error_codes')) show_error_codes = data['data']['show_error_codes'] ;
            if(data['data'].hasOwnProperty('api_functions')) api_functions = set_api_functions(data['data']['api_functions']) ;

            localStorage.setItem('show_messages',JSON.stringify(show_messages,null,9)) ;
            localStorage.setItem('show_error_codes',JSON.stringify(show_error_codes,null,9)) ;
            localStorage.setItem('api_functions',JSON.stringify(api_functions,null,9)) ;

            put_footer_data() ;
            
            var show_msg_ok_af = "" ;
            var show_msg_error_af = "" ;
            
            if((typeof api_functions == "object") && (api_functions != null))
            {
                if(api_functions.hasOwnProperty('result_data'))
                {
                    var result_data = api_functions.hasOwnProperty('result_data') ;
                    if(result_data.hasOwnProperty('success_msg_key') && result_data.hasOwnProperty('success_msg_show') && result_data.hasOwnProperty('error_msg_key') && result_data.hasOwnProperty('error_msg_show'))
                    {
                        
                        if((result_data['success_msg_key'].length > 0) && (result_data['error_msg_key'].length > 0))
                        {
                            if((typeof show_messages == "object") && (show_messages != null))
                            {
                                if(show_messages.hasOwnProperty(result_data['success_msg_key']))
                                {
                                    show_msg_ok_af = show_messages[result_data['success_msg_key']] ;
                                }
                                else
                                {
                                    show_msg_ok_af = result_data['success_msg_show'] ;
                                }
                                
                                if(show_messages.hasOwnProperty(result_data['error_msg_key']))
                                {
                                    show_msg_error_af = show_messages[result_data['error_msg_key']] ;
                                }
                                else
                                {
                                    show_msg_error_af = result_data['error_msg_show'] ;
                                }
                            }
                        }
                    }
                }
            
                if(api_functions.hasOwnProperty('get_credentials'))
                {
                    if(data.hasOwnProperty('web_api_session_data') && data.hasOwnProperty('web_api_session_id_expire'))
                    {
                        if(check_login(data['web_api_session_data'],data['web_api_session_id_expire']))
                        {
                        }
                        else
                        {
                            show_login_data_mgnt(api_functions['get_credentials']) ;
                        }
                    }
                    else
                    {
                        show_login_data_mgnt(api_functions['get_credentials']) ;
                    }
                }
            }
            
            if(show_msg_ok_af.length > 0)
            {
                show_alert_data(show_msg_ok_af,'alert_ok') ;
            }
        }
        else
        {
            show_alert_data('BAD_RESPONSE_FORMAT','alert_error') ;
            //api_data_receive_error("BAD_RESPONSE_FORMAT",id_name_for_div_content_in) ;
        }
    }
}

function api_data_receive_api_public_functions_ok(data_in,id_name_for_div_content_in,params_in=null)
{
    var data = data_in ;
    
    if(typeof data == "object")
    {
        //alert(JSON.stringify(data,null,9) + '\n\n') ;
        if(data.hasOwnProperty('error') && data['error'])
        {
            if(data.hasOwnProperty('errors'))
            {
                var errors = data['errors'] ;
                var err_msg = "<br/>\n" ;
                for(var key in errors)
                {
                    if(errors.hasOwnProperty(key))
                    {
                        var errors_key = errors[key] ;
                        if((typeof(show_error_codes) == 'object') && (show_error_codes != null) && show_error_codes.hasOwnProperty(errors_key))
                        {
                            err_msg = err_msg + show_error_codes[errors_key] + "<br/>\n" ;
                        }
                        else
                        {
                            err_msg = err_msg + errors_key + "<br/>\n" ;
                        }
                    }
                }
                
                err_msg = err_msg + "<br/>\n" ;
                show_alert_data(err_msg,'alert_error') ;

                if(data.hasOwnProperty('wrong_params'))
                {
                    var wrong_params = data['wrong_params'] ;
                    
                    //alert('WP:\n\n' + JSON.stringify(data,null,9) + '\n\n') ;
                    
                    if(typeof wrong_params == "object")
                    {
                        set_wrong_inputs(wrong_params) ;
                        var data_out = '' ;
                        
                        for(var key in wrong_params)
                        {
                            if(wrong_params.hasOwnProperty(key))
                            {
                                data_out = data_out + wrong_params[key] + '<br/>\n';
                            }
                        }
                        
                        //alert('WRONG: \n' + data_out) ;
                    }
                }
    
            }
        }
        else if(data.hasOwnProperty('result') && data['result'] && data.hasOwnProperty('data'))
        {
            
            if(data['data'].hasOwnProperty('show_messages')) show_messages = set_show_messages(data['data']['show_messages']) ;
            if(data['data'].hasOwnProperty('show_error_codes')) show_error_codes = data['data']['show_error_codes'] ;
            if(data['data'].hasOwnProperty('api_functions')) api_functions = set_api_functions(data['data']['api_functions']) ;

            localStorage.setItem('show_messages',JSON.stringify(show_messages,null,9)) ;
            localStorage.setItem('show_error_codes',JSON.stringify(show_error_codes,null,9)) ;
            localStorage.setItem('api_functions',JSON.stringify(api_functions,null,9)) ;

            put_footer_data() ;

            var show_msg_ok_af = "" ;
            var show_msg_error_af = "" ;

            if((typeof api_functions == "object") && (api_functions != null))
            {
                if(api_functions.hasOwnProperty('result_data'))
                {
                    var result_data = api_functions.hasOwnProperty('result_data') ;
                    if(result_data.hasOwnProperty('success_msg_key') && result_data.hasOwnProperty('success_msg_show') && result_data.hasOwnProperty('error_msg_key') && result_data.hasOwnProperty('error_msg_show'))
                    {
                        
                        if((result_data['success_msg_key'].length > 0) && (result_data['error_msg_key'].length > 0))
                        {
                            if((typeof show_messages == "object") && (show_messages != null))
                            {
                                if(show_messages.hasOwnProperty(result_data['success_msg_key']))
                                {
                                    show_msg_ok_af = show_messages[result_data['success_msg_key']] ;
                                }
                                else
                                {
                                    show_msg_ok_af = result_data['success_msg_show'] ;
                                }
                                
                                if(show_messages.hasOwnProperty(result_data['error_msg_key']))
                                {
                                    show_msg_error_af = show_messages[result_data['error_msg_key']] ;
                                }
                                else
                                {
                                    show_msg_error_af = result_data['error_msg_show'] ;
                                }
                            }
                        }
                    }
                }

                var rec_commands = get_get_inputs(false) ;

                if((typeof(rec_commands) == 'object') && (rec_commands != null))
                {
                    if(!rec_commands.hasOwnProperty('lang')) rec_commands['lang'] = get_Browser_lang() ;
                    if(rec_commands.hasOwnProperty('rec_command') && (typeof(rec_commands['rec_command']) == 'string') && (rec_commands['rec_command'].length > 0))
                    {
                        var rec_command = rec_commands['rec_command'] ;
                        delete rec_commands['rec_command'] ;
                        //alert('ACA: ' + rec_command) ;
                        //alert('C: ' + rec_command + '\n' + JSON.stringify(rec_commands,null,9)) ;
                        send_api_command(rec_command,rec_commands) ;
                    }
                    else
                    {
                        var rec_command = 'sign_up' ;
                        //alert('C: ' + rec_command + '\n' + JSON.stringify(rec_commands,null,9)) ;
                        send_api_command(rec_command,rec_commands) ;
                    }
                }
                else
                {
                    var rec_command = 'sign_up' ;
                    rec_commands = new Object() ;
                    rec_commands['lang'] = get_Browser_lang() ;
                    send_api_command(rec_command,rec_commands) ;
                    //alert('OJO') ;
                }
            }
            
            if(show_msg_ok_af.length > 0)
            {
                show_alert_data(show_msg_ok_af,'alert_ok') ;
            }
        }
        else
        {
            show_alert_data('BAD_RESPONSE_FORMAT','alert_error') ;
            //api_data_receive_error("BAD_RESPONSE_FORMAT",id_name_for_div_content_in) ;
        }
    }
}


function api_data_receive_ok(data_in,id_name_for_div_content_in,params_in=null)
{
    var data = data_in ;
    
    var id_name_for_div_content = id_name_for_div_content_in ;
    
    if(typeof data == "object")
    {
        //var data_out = JSON.stringify(data,null,9) ;
        //alert('RES:\n\n' + data_out + '\n\n') ;
        
        if(data.hasOwnProperty('error') && data['error'])
        {
            if(data.hasOwnProperty('errors'))
            {
                var errors = data['errors'] ;
                var err_msg = "" ;
                for(var key in errors)
                {
                    if(errors.hasOwnProperty(key))
                    {
                        var errors_key = errors[key] ;
                        if((typeof(show_error_codes) == 'object') && (show_error_codes != null) && show_error_codes.hasOwnProperty(errors_key))
                        {
                            err_msg = err_msg + show_error_codes[errors_key] + "<br/>\n" ;
                        }
                        else
                        {
                            err_msg = err_msg + errors_key + "<br/>\n" ;
                        }
                    }
                }
                
                err_msg = err_msg + '<br/>\n' ;
                //err_msg = err_msg + 'ERROR:<br/>\n' ;
                
                show_alert_data(err_msg,'alert_error') ;
                
            }

            if(data.hasOwnProperty('wrong_params'))
            {
                var wrong_params = data['wrong_params'] ;
                
                //alert('WP:\n\n' + JSON.stringify(data,null,9) + '\n\n') ;
                
                if(typeof wrong_params == "object")
                {
                    set_wrong_inputs(wrong_params) ;
                    var data_out = '' ;
                    
                    for(var key in wrong_params)
                    {
                        if(wrong_params.hasOwnProperty(key))
                        {
                            data_out = data_out + wrong_params[key] + '<br/>\n';
                        }
                    }
                    
                    //alert('WRONG: \n' + data_out) ;
                }
            }

            //alert('ACA: \n' + JSON.stringify(data,null,9) + '\n') ;
            if(data.hasOwnProperty('command') && (typeof(data['command']) == 'string') && (data['command'] == 'get_credentials'))
            {
                var current_href = window.location.href ;
                var current_get_parms = get_get_inputs(true) ;
                var next_href = window.location.href ;
                var func_out = "window.location.href = '" + next_href + "' ;";
                setTimeout(func_out,1800) ;
            }
        }
        else if(data.hasOwnProperty('result') && data.hasOwnProperty('data'))
        {
            var result = data['result'] ;
            var result_type = null ;
            var success_msg_key = null ;
            var success_msg_show = null ;
            var error_msg_key = null ;
            var error_msg_show = null ;
            
            var msg_out = null ;
            
            var do_reload = false ;
            
            id_name_for_div_content = 'vps-control-data' ;
            
            if(data.hasOwnProperty('command') && api_functions.hasOwnProperty(data['command']) && api_functions[data['command']].hasOwnProperty('result_data'))
            {
                var result_data = api_functions[data['command']]['result_data'] ;
                //var result_data_json = JSON.stringify(api_functions,null,9) ;
                //alert('\n\n' + current_menu_node_id + '\n\n') ;
                
                if(result_data.hasOwnProperty('type'))
                {
                    result_type = result_data['type'] ;
                    if(result_data.hasOwnProperty('success_msg_key') && result_data.hasOwnProperty('success_msg_show') && result_data.hasOwnProperty('error_msg_key') && result_data.hasOwnProperty('error_msg_show'))
                    {
                        success_msg_key = result_data['success_msg_key'] ;
                        success_msg_show = result_data['success_msg_show'] ;
                        error_msg_key = result_data['error_msg_key'] ;
                        error_msg_show = result_data['error_msg_show'] ;
                        
                        if(result)
                        {
                            if((success_msg_key.length > 0) && show_messages.hasOwnProperty(success_msg_key) && (show_messages[success_msg_key].length > 0))
                            {
                                msg_out = show_messages[success_msg_key] ;
                            }
                            else if(success_msg_show.length > 0)
                            {
                                msg_out = success_msg_show ;
                            }
                            else
                            {
                                msg_out = 'OK' ;
                            }
                        }
                        else
                        {
                            if((error_msg_key.length > 0) && show_messages.hasOwnProperty(error_msg_key) && (show_messages[error_msg_key].length > 0))
                            {
                                msg_out = show_messages[error_msg_key] ;
                            }
                            else if(error_msg_show.length > 0)
                            {
                                msg_out = error_msg_show ;
                            }
                            else
                            {
                                msg_out = 'ERROR' ;
                            }
                        }
                    }
                    
                    if(result_data.hasOwnProperty('do_reload')) do_reload = result_data['do_reload'] ;
                    
                    var params = null ;
                    
                    if((params_in != null) && (typeof(params_in) == 'object'))
                    {
                        if((typeof(params_in) == "object") && params_in.hasOwnProperty('command_args'))
                        {
                            params = JSON.parse(urlsafe_b64decode(params_in['command_args'])) ;
                            if((params != null) && (typeof(params) == 'object') && params.hasOwnProperty('get_default_values') && (params['get_default_values'] == "true")) do_reload = false ;
                        }
                    }
                    
                    switch(result_type)
                    {
                        case "boolean":
                            var data_show = get_boolean_result_show(result,msg_out) ;
                            //alert('ACA: ' + id_name_for_div_content + '\n\n' + data_show + '\n\n') ;
                            show_in_element_vps_control(id_name_for_div_content,data_show) ;
                        break ;
                        
                        
                        default:
                    }
                    
                    post_result_command(data,result_type) ;
                    
                    if(do_reload)
                    {
                        reload_current_menu_id(data) ;
                    }
                }
            }
        }
        else
        {
            show_alert_data('BAD_RESPONSE_FORMAT','alert_error') ;
        }
    }
}

function api_data_receive_error(data,id_name_for_div_content,params_in=null)
{
    var out_msg = "ERROR: " + data ;
    
    show_alert_data(out_msg,'alert_error') ;
    
    return true ;
}

function proc_form(prefix_vars,command='get_api_functions',reset_step=false)
{
    var result = false ;
    hide_modal('login') ;

    var data = get_inputs_by_id_prefix(prefix_vars) ;

    if(reset_step)
    {
        if(data.hasOwnProperty('step') && is_int(data['step']))
        {
            data['step'] = parseInt(data['step']) - 1 ;
            if(data['step'] < 0) data['step'] = 0 ;
        }
    }

    if(goto_top)
    {
        goto_top = false ;
        window.scrollTo(0,0) ;
        document.getElementsByTagName('body')[0].scrollTop = 0 ; 
    }
    
    //var data_json = JSON.stringify(data,null,9) ;
    //alert("SER 0: " + command + '\n\n' + data_json + '\n\n') ;
    result = send_api_command(command,data) ;
    
    //alert(data) ;
    
    return result ;
}

function clear_local_storage()
{
    localStorage.removeItem('user_full_data'); 
    localStorage.removeItem('show_messages'); 
    localStorage.removeItem('show_error_codes'); 
    localStorage.removeItem('api_functions');
    localStorage.removeItem('web_api_session_data'); 
    localStorage.removeItem('web_api_session_id_expire'); 
    localStorage.removeItem('table_data_str'); 
    localStorage.removeItem('table_data_field_sorter');
}

function api_logout(full_logout=false)
{
    web_api_session_data = null ;
    web_api_session_id_expire = null ;
    
    if(full_logout)
    {
        show_messages = null ;
        show_error_codes = null ;
        user_full_data = null ;
        unset_upper_var('upper-var') ;

        show_in_element('controls',' ') ;
        show_in_element('api_command_form',' ',false) ;
        show_in_element('vps-control-data',' ',false) ;
        show_hide_element('vps-control-form',false) ;
        show_hide_element('vps-control-data',false) ;
        clear_local_storage() ;

        var current_href = window.location.href ;
        var current_get_parms = get_get_inputs(true) ;
        var next_href = window.location.href ;
        var func_out = "window.location.href = '" + next_href + "' ;";

        modal_blocked = false ;
        hide_modal('loader');
        setTimeout(func_out,500) ;
    }
    else
    {
        clearInterval(check_login_interval_id) ;
        check_login_interval_id = null ;

        modal_blocked = false ;
        hide_modal('loader');
        
        api_function = null ;
        api_params = null ;
        api_function = 'get_api_functions' ;
        api_params = new Object() ;
        send_api_command(api_function,api_params) ;
    }
}

function check_login_interval()
{
    var result = false ;
    if(!check_login(web_api_session_data,web_api_session_id_expire))
    {
        api_logout(false) ;
    }
    
    return result ;
}

function set_show_messages(show_messages_in)
{
    var result ;
    
    if(typeof show_messages_in == "object")
    {
        result = show_messages_in ;
        
        for(var key in show_messages_in)
        {
            if(show_messages_in.hasOwnProperty(key))
            {
                var prefix_first = key.substring(0,1) ;
                var prefix_num = key.substring(1,7) ;
                var betw = key.substring(7,8) ;
                
                if(((prefix_first == 'A') || (prefix_first == 'U')) && (!isNaN(prefix_num)) && (betw == '_'))
                {
                    var value = show_messages_in[key] ;
                    var key_end = key.substring(8) ;
                    key_end = 'MENU_BUTTONS_' + key_end.toUpperCase() ;
                    
                    if(!result.hasOwnProperty(key_end))
                    {
                        result[key_end] = value ;
                    }
                }
            }
        }
    }
    
    return result ;
}

function set_api_functions(api_functions_in)
{
    var result ;
    
    if(typeof api_functions_in == "object")
    {
        result = api_functions_in ;
        
        //var api_functions_out = 'API_FUNCTIONS \n\n' + JSON.stringify(api_functions_in,null,9) + '\n\n<br/>\n\n' ;
        
        //alert(api_functions_out);
        
        for(var key in api_functions_in)
        {
            if(api_functions_in.hasOwnProperty(key))
            {
                var left_text_key = 'left_text' ;
                var right_text_key = 'right_text' ;
                var success_msg_key = 'success_msg_key' ;
                var error_msg_key = 'error_msg_key' ;
                
                var api_function = api_functions_in[key] ;
                
                for(var key_f in api_function)
                {
                    if(api_function.hasOwnProperty(key_f))
                    {
                        var api_function_def = api_function[key_f] ;
                        
                        for(var key_def in api_function_def)
                        {
                            if(key_def == left_text_key)
                            {
                                if(show_messages.hasOwnProperty(api_functions_in[key][key_f][key_def]) && (api_functions_in[key][key_f][key_def].length > 0)) result[key][key_f][key_def] = show_messages[api_functions_in[key][key_f][key_def]] ;
                            }
                            
                            if(key_def == right_text_key)
                            {
                                if(show_messages.hasOwnProperty(api_functions_in[key][key_f][key_def]) && (api_functions_in[key][key_f][key_def].length > 0)) result[key][key_f][key_def] = show_messages[api_functions_in[key][key_f][key_def]] ;
                            }
                            
                            if(key_def == success_msg_key)
                            {
                                var key_def_out = 'success_msg_show' ;
                                if(show_messages.hasOwnProperty(api_functions_in[key][key_f][key_def]) && (api_functions_in[key][key_f][key_def].length > 0)) result[key][key_f][key_def_out] = show_messages[api_functions_in[key][key_f][key_def]] ;
                            }
                            
                            if(key_def == error_msg_key)
                            {
                                var key_def_out = 'error_msg_show' ;
                                if(show_messages.hasOwnProperty(api_functions_in[key][key_f][key_def]) && (api_functions_in[key][key_f][key_def].length > 0)) result[key][key_f][key_def_out] = show_messages[api_functions_in[key][key_f][key_def]] ;
                            }
                        }
                    }
                }
            }
        }
    }
    
    return result ;
}

function show_in_element_vps_control(id_element,data)
{
    var result = false ;
    
    var local_show_id_element = null ;
    
    var offset_form = 45 ;
    
    if(typeof(vps_control_layers) == 'object')
    {
        for(var key in vps_control_layers)
        {
            if(vps_control_layers.hasOwnProperty(key))
            {
                //show_hide_element(vps_control_layers[key],false) ;
                //alert('ACA: ' + id_element + ' -> ' + vps_control_layers[key]) ;
                if(id_element == vps_control_layers[key]) local_show_id_element = id_element ;
                
                if(vps_control_layers[key] == 'vps-control-form')
                {
                    show_in_element('api_command_form','',false) ;
                    //offset_form = get_scroll_top(local_show_id_element) ;
                }
                else
                {
                    show_in_element(vps_control_layers[key],'',false) ;
                }
                
                //alert('ACA: ' + vps_control_layers[key] + ' -> ' + false) ;
                show_hide_element(vps_control_layers[key],false) ;
            }
            
        }
        
        var local_height = get_scroll_top_null(data) + offset_form ;
        //alert('LOCAL HEIGHT:' + local_height + ' -> ' + offset_form) ;
        
        if(local_show_id_element != null)
        {
            if(local_show_id_element == 'vps-control-form')
            {
                show_in_element('api_command_form',data,true) ;
                show_hide_element(local_show_id_element,true) ;
            }
            else
            {
                show_in_element(local_show_id_element,data) ;
            }
            
            //alert(local_show_id_element + '\n\n' + JSON.stringify(data,null,9) + '\n\n') ;

            if(local_height !== false)
            {
                //alert('LOCAL HEIGHT: ' + local_height) ;
                set_height('vps-control-app',local_height) ;
            }
            
            result = true ;
        }
    }

    return result ;
}

function get_scroll_top_null(data)
{
    var result = false ;
    
    var null_id = 'vps-control-null' ;
    var id_null = document.getElementById(null_id) ;
    id_null.innerHTML = '' ;
    id_null.innerHTML = data ;
    result = get_scroll_top(null_id) ;
    
    if(result != false) result = result + 0 ;
    
    //alert('STN: ' + result) ;
    
    id_null.innerHTML = '<div></div>\n' ;
    
    return result ;
}

function update_height(id_elem)
{
  var result = false ;

  var offset_form = 45 ;
  var id_height = document.getElementById(id_elem) ;
  var data = id_height.innerHTML ;
  //var new_height = parseInt(id_height.offsetHeight) + parseInt(id_height.scrollTop) ;
  //var new_height = parseInt(id_height.offsetHeight) ;
  var new_height = get_scroll_top_null(data) + offset_form ;

  set_height('vps-control-app',new_height) ;

  return result ;
}

function set_wrong_inputs(wrong_params)
{
    //var inputs_elem = document.getElementsByTagName("INPUT") ;
    var inputs_elem = document.querySelectorAll(form_input_types) ;
    
    if(typeof(wrong_params) === 'object')
    {
        for(var key in wrong_params)
        {
            if(wrong_params.hasOwnProperty(key))
            {
                var wrong_param_msgs = wrong_params[key] ;
                
                if(typeof(inputs_elem) === 'object')
                {
                    for(var i in inputs_elem)
                    {
                        if(inputs_elem.hasOwnProperty(i))
                        {
                            var input_elem = inputs_elem[i] ;
                            if(input_elem.name == key)
                            {
                                if(typeof(wrong_param_msgs) === 'object')
                                {
                                    var val_msg = '' ;
                                    for(var j in wrong_param_msgs)
                                    {
                                        if(wrong_param_msgs.hasOwnProperty(j))
                                        {
                                            if(show_error_codes.hasOwnProperty(wrong_param_msgs[j]))
                                            {
                                                val_msg = val_msg + show_error_codes[wrong_param_msgs[j]] + '\n' ;
                                            }
                                            else
                                            {
                                                val_msg = val_msg + wrong_param_msgs[j] + '\n' ;
                                            }
                                        }
                                    }

                                    //if(val_msg.length == 0) val_msg = "Wrong field" ;
                                    input_elem.setCustomValidity(val_msg) ;
                                    //alert('ACA: ' + input_elem.name + ' -> ' + val_msg) ;
                                }
                            }
                        }
                    }
                }
            }
        }
    }
}

function compare_table_data(a,b)
{
    var result = 0 ;
    
    var field = false ;
    
    if(table_data_field_sorter.hasOwnProperty('field')) field = table_data_field_sorter['field'] ;
    
    if((field != false) && (typeof(field) == 'string') && a.hasOwnProperty(field) && b.hasOwnProperty(field))
    {
        var a_data = a[field] ;
        var b_data = b[field] ;

        //if(!isNaN(a_data)) alert('ACA: ' + a_data) ;
        //if(!isNaN(b_data)) alert('ACA: ' + b_data) ;
        
        if(!isNaN(a_data)) a_data = 0 + parseFloat(a_data) ;
        if(!isNaN(b_data)) b_data = 0 + parseFloat(b_data) ;
        

        if(a_data < b_data)
        {
            result = -1 ;
        }
        else if(a_data > b_data)
        {
            result = 1 ;
        }
        else
        {
            result = 0 ;
        }
    }
    else if((field != false) && (typeof(field) == 'number') && a.hasOwnProperty(field) && b.hasOwnProperty(field))
    {
        if(a[field] < b[field])
        {
            result = -1 ;
        }
        else if(a[field] > b[field])
        {
            result = 1 ;
        }
        else
        {
            result = 0 ;
        }
    }
    else if((field != false) && (typeof(field) == 'bigint') && a.hasOwnProperty(field) && b.hasOwnProperty(field))
    {
        if(a[field] < b[field])
        {
            result = -1 ;
        }
        else if(a[field] > b[field])
        {
            result = 1 ;
        }
        else
        {
            result = 0 ;
        }
    }
    
    return result ;
}

function manage_searcher(data)
{
    var result = false ;
    
    var fields = null ;
    
    var search = '' ;
    
    var field_str = '' ;
    
    if(table_data_field_sorter.hasOwnProperty('filter_search'))
    {
        search = table_data_field_sorter['filter_search'] ;
        search = search.trim() ;
        search = slugify(search) ;
        if(search.length > 0) search = new RegExp(search,'i') ;
    }
    
    
    if(table_data_field_sorter.hasOwnProperty('filter_fields')) fields = table_data_field_sorter['filter_fields'] ;
    
    if((search == false) || (search == null))
    {
        result = true ;
    }
    else if(typeof(search) == 'string')
    {
        result = true ;
    }
    else if(typeof(search) == 'object')
    {
        if((fields != false) && (typeof(fields) == 'object') && (fields != null))
        {
            for(var field in fields)
            {
                if(data.hasOwnProperty(field))
                {
                    field_str = slugify(data[field]) ;
                    
                    if(field_str.search(search) != -1)
                    {
                        result = true ;
                    }
                }
            }
        }
    }
    
    //alert(JSON.stringify(fields,null,9)) ;
    //alert('R: '+ search + ' -> ' + field_str + ' -> ' + result + '\n') ;
    
    return result ;
}

function manage_searcher_box(data)
{
    var result = false ;
    
    var fields = null ;
    
    var search = '' ;
    
    var field_str = '' ;
    
    if(table_data_field_sorter.hasOwnProperty('filter_search'))
    {
        search = table_data_field_sorter['filter_search'] ;
        search = search.trim() ;
        search = slugify(search) ;
        if(search.length > 0) search = new RegExp(search,'i') ;
    }
    
    if(table_data_field_sorter.hasOwnProperty('filter_fields')) fields = table_data_field_sorter['filter_fields'] ;
    
    if((search == false) || (search == null))
    {
        result = true ;
    }
    else if(typeof(search) == 'string')
    {
        result = true ;
    }
    else if(typeof(search) == 'object')
    {
        if((fields != false) && (typeof(fields) == 'object') && (fields != null))
        {
            for(var field in fields)
            {
                if((typeof(data) == 'object') && (data != null))
                {
                    for(var i_box in data)
                    {
                        if((typeof(data[i_box]) == 'object') && (data[i_box] != null))
                        {
                            for(var i in data[i_box])
                            {
                                if((typeof(data[i_box][i]) == 'object') && data[i_box][i].hasOwnProperty('key') && data[i_box][i].hasOwnProperty('value'))
                                {
                                    if(field == data[i_box][i]['key'])
                                    {
                                        field_str = slugify(data[i_box][i]['value']) ;
                                        
                                        if(field_str.search(search) != -1)
                                        {
                                            result = true ;
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
    }
    
    //alert(JSON.stringify(fields,null,9)) ;
    //alert(JSON.stringify(data,null,9)) ;
    //alert('R: '+ search + ' -> ' + field_str + ' -> ' + result + '\n') ;
    
    return result ;
}

function check_get_inputs()
{
    var result = false ;

    var str_parms = window.location.search.substr(1);

    //var url_loc = location.protocol + '//' + location.host + location.pathname
    var url_loc = location.pathname

    var str_split = str_parms.split('&') ;

    if((typeof(str_split) == 'object') && (str_split != null))
    {
        for(var i in str_split)
        {
            if((str_split[i].match(new RegExp("=", "g")) || []).length = 1)
            {
                var parm_data = str_split[i].split('=');
                if((typeof(parm_data) == 'object') && (parm_data != null))
                {
                    if(parm_data.hasOwnProperty(0) && parm_data.hasOwnProperty(1))
                    {
                        if(typeof(result) != 'object') result = new Object();
                        result[parm_data[0]] = parm_data[1] ;
                    }
                }
            }
        }
    }

    proc_get_inputs(result) ;
    change_browser_url(url_loc) ;

    return result ;
}

function proc_get_inputs(get_parms)
{
    var result = false ;

    if((typeof(get_parms) == 'object') && (get_parms != null))
    {
        if(get_parms.hasOwnProperty('cmni') && (typeof(get_parms['cmni']) == 'string') && (get_parms['cmni'].length > 0))
        {
            current_menu_node_id = get_parms['cmni'] ;
            var menu_data_out = get_control_menu(get_parms['cmni']) ;
            show_in_element('controls',menu_data_out);
        }

        if(get_parms.hasOwnProperty('data_get') && get_parms.hasOwnProperty('act') && get_parms.hasOwnProperty('redirect') && (get_parms['redirect'] == "true"))
        {
            var parms_out = get_parms['data_get'] ;
            parms_out = urlsafe_b64decode(parms_out);
            parms_out = JSON.parse(parms_out);

            if((typeof(parms_out) != 'object') || (parms_out == null)) parms_out = new Object();

            parms_out['act'] = get_parms['act'] ;
            parms_out['redirect'] = get_parms['redirect'] ;

            if(parms_out.hasOwnProperty('function_res'))
            {
                var cmd_out = parms_out['function_res'] ;
                delete parms_out['function_res'] ;
                send_api_command(cmd_out,parms_out);
            }
        }
    }

    return result ;
}

function proc_form_2checkout(function_parms_in,prefix_vars,command='get_api_functions',reset_step=false)
{
    var result = false ;

    if(OBJ_2checkout.hasOwnProperty('jsPaymentClient') && OBJ_2checkout.hasOwnProperty('component'))
    {
        var function_parms = JSON.parse(urlsafe_b64decode(function_parms_in)) ;

        const billingDetails = new Object() ;
        billingDetails['name'] = get_input_select_by_name('2CHECKOUT_name').value ;
    
        OBJ_2checkout['jsPaymentClient'].tokens.generate(OBJ_2checkout['component'],billingDetails).then((response) => {

        if(response.hasOwnProperty('token'))
        {
            get_input_select_by_name('EesToken').value = response.token;
            //alert(get_input_select_by_name('EesToken').value) ;
            //alert(get_input_select_by_name('step').value) ;
            get_input_select_by_name('step').value = "proc_2checkout";
            //alert(get_input_select_by_name('step').value) ;
            //alert('PV: ' + prefix_vars + '\n' + 'COMMAND: ' + command + '\n' + 'RS: ' + reset_step + '\n') ;
            proc_form(prefix_vars,command,reset_step) ;
        }
        else
        {
            alert('Error') ;
        }
        }).catch((description) => {
            //alert('NAME: ' + billingDetails['name'] + '\nERROR: ' + error + '\n');
            //alert('NAME: ' + billingDetails['name'] + '\nERROR: ' + description + '\n');
        });
    }
    return result ;
}

function load_2checkout(parms_in=null)
{
    var result = false ;
    var params = null ;

    if(parms_in != null)
    {
        params = JSON.parse(urlsafe_b64decode(parms_in));

        if(params.hasOwnProperty('include') && params.hasOwnProperty('include_callback') && params.hasOwnProperty('merchant_code') && params.hasOwnProperty('html_dom_elem_id'))
        {
            load_script(params['include'],params['include_callback'],urlsafe_b64encode(JSON.stringify(params,null,9)),false) ;
        }
    }

    return result ;
}

function load_paypalcheckout(parms_in=null)
{
    var result = false ;
    var params = null ;

    if(parms_in != null)
    {
        params = JSON.parse(urlsafe_b64decode(parms_in)) ;

        var paypal_include = params['include'] ;

        load_script(paypal_include,'render_paypal_checkout',parms_in,false) ;

        //var params_out = JSON.stringify(params,null,9) ;
        //alert(params_out + '\n') ;
        //params = JSON.parse(urlsafe_b64decode(parms_in));

        /*
        if(params.hasOwnProperty('include') && params.hasOwnProperty('include_callback') && params.hasOwnProperty('merchant_code') && params.hasOwnProperty('html_dom_elem_id'))
        {
            load_script(params['include'],params['include_callback'],urlsafe_b64encode(JSON.stringify(params,null,9)),false) ;
        }
        */
    }

    return result ;
}

function render_paypal_checkout(parms_in)
{
    var result = false ;
    var params = null ;

    if(parms_in != null)
    {
        params = JSON.parse(urlsafe_b64decode(parms_in)) ;

        var paypal_data = new Object() ;
        //paypal_data['id'] = params['data']['id'] ;
        //paypal_data['style']['label'] = 'checkout' ;
        paypal_data['style'] = new Object() ;
        paypal_data['style']['layout'] = 'vertical' ;
        paypal_data['style']['color'] = 'blue' ;
        paypal_data['style']['shape'] = 'pill' ;
        paypal_data['style']['label'] = 'checkout' ;
        paypal_data['style']['height'] = 45 ;

        //var paypal_data_out = JSON.stringify(paypal_data,null,9) ;
        paypal_data['createOrder'] = function (data, actions) {
            return params['data']['id'] ;
        } ;

        paypal_data['onApprove'] = function (data, actions) {
            return exec_paypal_checkout(params,data,'onApprove') ;
        } ;

        paypal_data['onCancel'] = function (data, actions) {
            return exec_paypal_checkout(params,data,'onCancel') ;
        } ;


        paypal_data['onError'] = function (err) {
            return exec_paypal_checkout(params,err,'onError') ;
        } ;

        paypal_data['onInit'] = function (data, actions) {
            setTimeout('update_height("vps-control-form") ;',1400) ;
            return true ;
        } ;

        paypal_data['onClick'] = function (data, actions) {
            setTimeout('update_height("vps-control-form") ;',1400) ;
            return true ;
        } ;

        var paypal_id = '#' + params['html_dom_elem_id'] ;

        paypal.Buttons(paypal_data).render(paypal_id) ;

        update_height("vps-control-form") ;

        //var params_out = JSON.stringify(params,null,9) ;
        //alert(params_out + '\n') ;
        //params = JSON.parse(urlsafe_b64decode(parms_in));

        /*
        if(params.hasOwnProperty('include') && params.hasOwnProperty('include_callback') && params.hasOwnProperty('merchant_code') && params.hasOwnProperty('html_dom_elem_id'))
        {
            load_script(params['include'],params['include_callback'],urlsafe_b64encode(JSON.stringify(params,null,9)),false) ;
        }
        */
    }


    return result ;
}

function exec_paypal_checkout(params,data_in,action)
{
    var result = false ;

    data = JSON.stringify(data_in,null,9) ;
    //alert('ACTION: ' + action + '\n' + data + '\n') ;

    data = urlsafe_b64encode(data) ;

    get_input_select_by_name('PAYPALCHECKOUT_id').value = params['data']['id'] ;
    get_input_select_by_name('PAYPALCHECKOUT_action').value = action ;
    get_input_select_by_name('PAYPALCHECKOUT_action_result').value = data ;
    get_input_select_by_name('step').value = params['step'] ;

    proc_form('api_command_input_','set_pay',false) ;
    //get_input_select_by_name('PAYPALCHECKOUT_submit_set_pay').click() ;

    //form_submit('api_command_form') ;

    return result ;
}

function load_2checkout_callback(parms_in=null)
{
    var result = false ;
    var params = null ;

    if(parms_in != null)
    {
        params = JSON.parse(urlsafe_b64decode(parms_in));

        //alert('\n\n' + urlsafe_b64decode(parms_in) + '\n\n');

        if((typeof(params) == 'object') && (params != null))
        {
            if(params.hasOwnProperty('merchant_code') && params.hasOwnProperty('html_dom_elem_id'))
            {
                //alert('MC: ' + params['merchant_code']);
                OBJ_2checkout['jsPaymentClient'] = new TwoPayClient(params['merchant_code']);
                var lang_2checkout = 'en' ;

                if((typeof(user_full_data) == 'object') && (user_full_data != null) && user_full_data.hasOwnProperty('user_sets') && user_full_data['user_sets'].hasOwnProperty('language'))
                {
                    if((typeof(user_full_data['user_sets']['language']) == 'string') && (user_full_data['user_sets']['language'].length >= 2))
                    {
                        lang_2checkout = user_full_data['user_sets']['language'].substring(0,2);
                    }
                }

                OBJ_2checkout['jsPaymentClient'].setup.setLanguage(lang_2checkout);

                if(typeof(style_2checkout) == 'object')
                {
                    if(style_2checkout == null)
                    {
                        OBJ_2checkout['component'] = OBJ_2checkout['jsPaymentClient'].components.create('card');
                    }
                    else
                    {
                        OBJ_2checkout['component'] = OBJ_2checkout['jsPaymentClient'].components.create('card',style_2checkout);
                    }
                }

                OBJ_2checkout['component'].mount('#' + params['html_dom_elem_id']);
            }
        }
    }

    return result ;
}

function enable_disable_2CHECKOUT_fiscalcode(parms_in)
{
    var result = false ;

    var parms = JSON.parse(urlsafe_b64decode(parms_in)) ;

    if((typeof(parms) == 'object') && (parms != null) && parms.hasOwnProperty('name_input_change') && (typeof(parms['name_input_change']) == 'string') && (parms['name_input_change'].length > 0))
    {
        if(parms.hasOwnProperty('name_input_key') && (typeof(parms['name_input_key']) == 'string') && (parms['name_input_key'].length > 0))
        {
            var id_elem_key = document.getElementsByName(parms['name_input_key'])[0] ;
            var id_elem_change = document.getElementsByName(parms['name_input_change'])[0] ;

            var enable_fiscalcode = false ;

            if(parms.hasOwnProperty('2CHECKOUT_fiscalcode_countries_required') && (typeof(parms['2CHECKOUT_fiscalcode_countries_required']) == 'object') && (parms['2CHECKOUT_fiscalcode_countries_required'] != null))
            {
                enable_fiscalcode = parms['2CHECKOUT_fiscalcode_countries_required'].includes(id_elem_key.value.toLowerCase()) ;
            }

            if(enable_fiscalcode)
            {
                if(id_elem_change.hasAttribute('disabled')) delete id_elem_change.disabled ;
                if(id_elem_change.hasAttribute('readonly')) delete id_elem_change.readonly ;
                if(id_elem_change.hasAttribute('disabled')) id_elem_change.removeAttribute('disabled') ;
                if(id_elem_change.hasAttribute('readonly')) id_elem_change.removeAttribute('readonly') ;

                id_elem_change.value = '' ;
                if(parms.hasOwnProperty('value_input_enabled') && (typeof(parms['value_input_enabled']) == 'string') && (parms['value_input_enabled'].length > 0))
                {
                    id_elem_change.value = parms['value_input_enabled'] ;
                }
            }
            else
            {
                id_elem_change.value = '' ;
                if(parms.hasOwnProperty('value_input_disabled') && (typeof(parms['value_input_disabled']) == 'string') && (parms['value_input_disabled'].length > 0))
                {
                    id_elem_change.value = parms['value_input_disabled'] ;
                }
                if(!id_elem_change.hasAttribute('disabled')) id_elem_change.disabled = 'true' ;
                if(!id_elem_change.hasAttribute('readonly')) id_elem_change.readonly = 'true' ;
            }
        }
    }

    return result ;
}

function enable_disable_root_password(parms_in)
{
    var result = false ;

    var parms = JSON.parse(urlsafe_b64decode(parms_in)) ;

    if((typeof(parms) == 'object') && (parms != null) && parms.hasOwnProperty('name_input_change') && (typeof(parms['name_input_change']) == 'string') && (parms['name_input_change'].length > 0))
    {
        if(parms.hasOwnProperty('name_input_key') && (typeof(parms['name_input_key']) == 'string') && (parms['name_input_key'].length > 0))
        {
            var id_elem_key = document.getElementsByName(parms['name_input_key'])[0] ;
            var id_elem_change = document.getElementsByName(parms['name_input_change'])[0] ;

            var enable_root_password = false ;

            if(id_elem_key.checked) enable_root_password = true ;


            if(enable_root_password)
            {
                if(id_elem_change.hasAttribute('disabled')) delete id_elem_change.disabled ;
                if(id_elem_change.hasAttribute('readonly')) delete id_elem_change.readonly ;
                if(id_elem_change.hasAttribute('disabled')) id_elem_change.removeAttribute('disabled') ;
                if(id_elem_change.hasAttribute('readonly')) id_elem_change.removeAttribute('readonly') ;

                id_elem_change.value = '' ;
            }
            else
            {
                id_elem_change.value = '' ;
                if(!id_elem_change.hasAttribute('disabled')) id_elem_change.disabled = 'true' ;
                if(!id_elem_change.hasAttribute('readonly')) id_elem_change.readonly = 'true' ;
            }
        }
    }

    return result ;
}

function enable_disable_ssh_pub_key(parms_in)
{
    var result = false ;

    var parms = JSON.parse(urlsafe_b64decode(parms_in)) ;

    if((typeof(parms) == 'object') && (parms != null) && parms.hasOwnProperty('name_input_change') && (typeof(parms['name_input_change']) == 'string') && (parms['name_input_change'].length > 0))
    {
        if(parms.hasOwnProperty('name_input_key') && (typeof(parms['name_input_key']) == 'string') && (parms['name_input_key'].length > 0))
        {
            var id_elem_key = document.getElementsByName(parms['name_input_key'])[0] ;
            var id_elem_change = document.getElementsByName(parms['name_input_change'])[0] ;

            var ssh_pub_keys = null ;

            var rows_disable = 1 ;
            var rows_enable = 50 ;

            var rows_out = rows_disable ;

            if(parms.hasOwnProperty('ssh_pub_key_rows_enable')) rows_enable = parms['ssh_pub_key_rows_enable'] ;
            if(parms.hasOwnProperty('ssh_pub_key_rows_disable')) rows_disable = parms['ssh_pub_key_rows_disable'] ;

            if(parms.hasOwnProperty('ssh_pub_keys') && (parms['ssh_pub_keys'] != null) && (typeof(parms['ssh_pub_keys']) == 'object'))
            {
                ssh_pub_keys = parms['ssh_pub_keys'] ;
            }

            var enable_ssh_pub_key = false ;

            var ssh_key_value = '' ;

            if(id_elem_key.value == "add_ssh_pub_key")
            {
                enable_ssh_pub_key = true ;
                rows_out = rows_enable ;
                ssh_key_value = '' ;
            }
            else if(id_elem_key.value == "no")
            {
                enable_ssh_pub_key = false ;
                rows_out = rows_disable ;
                ssh_key_value = '' ;
            }
            else
            {
                //if(is_int(id_elem_key.value))
                enable_ssh_pub_key = false ;
                rows_out = rows_enable ;
                if((ssh_pub_keys != null) && (typeof(ssh_pub_keys) == 'object') && (ssh_pub_keys.hasOwnProperty(id_elem_key.value)))
                {
                    ssh_key_value = ssh_pub_keys[id_elem_key.value] ;
                }
            }

            if(enable_ssh_pub_key)
            {
                if(id_elem_change.hasAttribute('disabled')) delete id_elem_change.disabled ;
                if(id_elem_change.hasAttribute('readonly')) delete id_elem_change.readonly ;
                if(id_elem_change.hasAttribute('disabled')) id_elem_change.removeAttribute('disabled') ;
                if(id_elem_change.hasAttribute('readonly')) id_elem_change.removeAttribute('readonly') ;
                id_elem_change.rows = rows_out ;
                id_elem_change.value = ssh_key_value ;
            }
            else
            {
                id_elem_change.value = ssh_key_value ;
                id_elem_change.rows = rows_out ;
                if(!id_elem_change.hasAttribute('disabled')) id_elem_change.disabled = 'true' ;
                if(!id_elem_change.hasAttribute('readonly')) id_elem_change.readonly = 'true' ;
            }
        }
    }

    update_height("vps-control-form") ;

    return result ;
}

function manage_vps_clear_timeout(reset_data=true,if_manage_vps_cancel=false)
{
    if(if_manage_vps_cancel) manage_vps_cancel = true ;
	if(manage_vps_timeout != false)
	{
		clearTimeout(manage_vps_timeout) ;
		manage_vps_timeout = false ;
	}

    if(reset_data)
    {
        table_data_prev = null ;
        manage_vps_counter = 0 ;
    }
}

function set_up_down_part(var_size_id,var_size_root_id,delta,min_root,min_part)
{
	var id_var_size = document.getElementById(var_size_id) ;
	var id_var_size_root = document.getElementById(var_size_root_id) ;

    //alert(id_var_size_root.value + ' <= ' + min_root + ' | ' + delta) ;
    //alert(id_var_size.value + ' <= ' + min_part + ' | ' + delta) ;

	if((parseInt(id_var_size_root.value)<=min_root)&&(delta>0)) return true;
	if((parseInt(id_var_size.value)<=min_part)&&(delta<256)) return true;

	if((parseInt(id_var_size.value)+parseInt(delta))<1) return true;
	if((parseInt(id_var_size_root.value)-parseInt(delta))<1) return true;

	id_var_size.value = parseInt(id_var_size.value) + parseInt(delta);
	id_var_size_root.value = parseInt(id_var_size_root.value) - parseInt(delta);

	return true;
}

function set_up_down_part_ADD(var_size_id,var_size_root_id,delta,min_root,min_part)
{

	var id_var_size = document.getElementById(var_size_id) ;
	var id_var_size_root = document.getElementById(var_size_root_id) ;

    var new_part_size = parseInt(id_var_size.value) + delta ;
    var new_root_size = parseInt(id_var_size_root.value) - new_part_size ;

    if(new_root_size < min_root) return true ;
    if(new_part_size < min_part) return true ;

	//if((parseInt(id_var_size.value)+parseInt(delta))<1) return true;
	//if((root_size-parseInt(delta))<1) return true;

	id_var_size.value = parseInt(id_var_size.value) + parseInt(delta);
	//id_var_size_root.value = parseInt(id_var_size_root.value) - parseInt(delta);

	return true;
}

function get_disk_from_id_prefix(prefix_in)
{
    var result = null ;

    var suffix_part = remove_prefix(prefix_in,'DISK_IN____') ;

    var data = suffix_part.split('_P_') ;

    if((data != null) && (typeof(data) == 'object') && data.hasOwnProperty(0) && is_int(data[0])) result = data[0] ;

    return result ;
}

function get_part_from_id_prefix(prefix_in)
{
    var result = null ;

    var suffix_part = remove_prefix(prefix_in,'DISK_IN____') ;

    var data = suffix_part.split('_P_') ;

    if((data != null) && (typeof(data) == 'object') && data.hasOwnProperty(1) && is_int(data[1])) result = data[1] ;

    return result ;
}

function delete_part(disks_data_in,id_part_data,id_disks_show,resize,disks_in,id_part_dele)
{
    var result = false ;

    var disks_data = urlsafe_b64decode(disks_data_in) ;
    disks_data = JSON.parse(disks_data) ;
    var disks = JSON.parse(urlsafe_b64decode(disks_in)) ;

    var prefix_part = remove_suffix(id_part_dele,'_DELE') ;
    var disk_del = get_disk_from_id_prefix(prefix_part) ;
    var part_del = get_part_from_id_prefix(prefix_part) ;

    var disk_inputs = get_inputs_by_id_prefix_return_id_value('DISK_IN____') ;

    var disk = null ;
    var part = null ;

    if((disk_inputs != null) && (typeof(disk_inputs) == 'object'))
    {
        for(var i in disk_inputs)
        {
            var key = i.split('_') ;

            if((key != null) && (typeof(key) == 'object'))
            {
                var last_key = key.length - 1 ;
                if(last_key >= 0)
                {
                    key = key[key.length - 1] ;
                }
                else
                {
                    key = '' ;
                }
            }
            else
            {
                key = '' ;
            }

            switch(key)
            {
                case "ADVANCED":
                    prefix_part = remove_suffix(i,'_' + key) ; 
                    disk = get_disk_from_id_prefix(prefix_part) ;
                    var advanced = false ;
                    if(disk_inputs[i] == 1) advanced = true ;
                    if(disks.hasOwnProperty(disk)) disks[disk][key.toLowerCase()] = advanced ;
                break ;

                case "MPNT":
                case "TYPE":
                case "SIZE":
                    prefix_part = remove_suffix(i,'_' + key) ; 
                    disk = get_disk_from_id_prefix(prefix_part) ;
                    part = get_part_from_id_prefix(prefix_part) ;
                    if(disks.hasOwnProperty(disk) && disks[disk].hasOwnProperty('partitions') && disks[disk]['partitions'].hasOwnProperty(part) && disks[disk]['partitions'][part].hasOwnProperty(key.toLowerCase())) disks[disk]['partitions'][part][key.toLowerCase()] = disk_inputs[i] ;
                break ;
            }

        }
    }

    if(disks.hasOwnProperty(disk_del) && disks[disk_del].hasOwnProperty('partitions') && disks[disk_del]['partitions'].hasOwnProperty(part_del))
    {
        var partitions_old = disks[disk_del]['partitions'] ;
        var partitions_new = new Object() ;

        if((partitions_old != null) && (typeof(partitions_old) == 'object'))
        {
            var part_index = 1 ;
            var sum_del = 0 ;

            for(var j in partitions_old)
            {
                if(j == part_del)
                {
                    sum_del = sum_del + parseInt(partitions_old[j]['size']) ;
                }
                else
                {
                    partitions_new[part_index] = partitions_old[j] ;
                    part_index = part_index + 1 ;
                }
            }

            var root_part = 0 ;
            if(disk_del == 0)
            {
                for(var j in partitions_new)
                {
                    if(partitions_new[j]['mpnt'] == '/') root_part = j ;
                }
            }
            else
            {
                root_part = 1 ;
            }

            partitions_new[root_part]['size'] = parseInt(partitions_new[root_part]['size']) + parseInt(sum_del) ;

            disks[disk_del]['partitions'] = partitions_new ;

            if(disk_del == 0)
            {
                if(Object.keys(partitions_new).length == 3)
                {
                    disks[disk_del]['advanced'] = false ;
                }
                else
                {
                    disks[disk_del]['advanced'] = true ;
                }
                
            }
            else
            {
                if(Object.keys(partitions_new).length == 1)
                {
                    disks[disk_del]['advanced'] = false ;
                }
                else
                {
                    disks[disk_del]['advanced'] = true ;
                }
            }

            if((disks_data != null) && (typeof(disks_data) == 'object') && disks_data.hasOwnProperty('disks'))
            {
                disks_data['disks'] = disks ;
                //alert(JSON.stringify(disks_data,null,9)) ;
                var disks_data_out = urlsafe_b64encode(JSON.stringify(disks_data,null,9)) ;
                get_vps_disks_seter(disks_data_out,id_part_data,id_disks_show,resize) ;
                result = true ;
            }
        }
    }

    return result ;
}

function get_disk_from_id_prefix_add(prefix_in)
{
    var result = null ;

    result = remove_prefix(prefix_in,'ADD_PART____') ;

    return result ;
}

function add_part(disks_data_in,id_part_data,id_disks_show,disks_in,id_part_add)
{
    var result = false ;

    var disks_data = urlsafe_b64decode(disks_data_in) ;

    //alert(disks_data) ;

    disks_data = JSON.parse(disks_data) ;
    var disks = urlsafe_b64decode(disks_in) ;

    //alert(disks);

    var disks = JSON.parse(disks) ;

    var prefix_part = remove_suffix(id_part_add,'_ADD') ;

    var part_id_mpnt = prefix_part + '_MPNT' ;
    var part_id_size = prefix_part + '_SIZE' ;
    var part_id_type = prefix_part + '_TYPE' ;

    var disk_add = get_disk_from_id_prefix_add(prefix_part) ;
    disk_add = parseInt(disk_add) ;

    var disk_inputs = get_inputs_by_id_prefix_return_id_value('DISK_IN____') ;

    if(document.getElementById(part_id_mpnt) && document.getElementById(part_id_size) && document.getElementById(part_id_type))
    {
        var part_type = document.getElementById(part_id_type).value ;
        var part_size = parseInt(document.getElementById(part_id_size).value) ;
        var part_used = 0 ;
        var part_mpnt = document.getElementById(part_id_mpnt).value.trim() ;
        var part_minsize = 0 ;
        var part_porc_used = 0 ;
        var part_uuid = '' ;

        var part_add_data = new Object() ;
        part_add_data['type'] = part_type ;
        part_add_data['size'] = part_size ;
        part_add_data['used'] = part_used ;
        part_add_data['mpnt'] = part_mpnt ;
        part_add_data['minsize'] = part_minsize ;
        part_add_data['porc_used'] = part_porc_used ;
        part_add_data['uuid'] = part_uuid ;

        if((disk_inputs != null) && (typeof(disk_inputs) == 'object'))
        {
            for(var i in disk_inputs)
            {
                var key = i.split('_') ;
    
                if((key != null) && (typeof(key) == 'object'))
                {
                    var last_key = key.length - 1 ;
                    if(last_key >= 0)
                    {
                        key = key[key.length - 1] ;
                    }
                    else
                    {
                        key = '' ;
                    }
                }
                else
                {
                    key = '' ;
                }
    
                switch(key)
                {
                    case "ADVANCED":
                        prefix_part = remove_suffix(i,'_' + key) ; 
                        disk = get_disk_from_id_prefix(prefix_part) ;
                        var advanced = false ;
                        if(disk_inputs[i] == 1) advanced = true ;
                        if(disks.hasOwnProperty(disk)) disks[disk][key.toLowerCase()] = advanced ;
                    break ;

                    case "MPNT":
                    case "TYPE":
                    case "SIZE":
                        prefix_part = remove_suffix(i,'_' + key) ; 
                        disk = get_disk_from_id_prefix(prefix_part) ;
                        part = get_part_from_id_prefix(prefix_part) ;
                        if(disks.hasOwnProperty(disk) && disks[disk].hasOwnProperty('partitions') && disks[disk]['partitions'].hasOwnProperty(part) && disks[disk]['partitions'][part].hasOwnProperty(key.toLowerCase())) disks[disk]['partitions'][part][key.toLowerCase()] = disk_inputs[i] ;
                    break ;
                }
            }
        }

        if(disks.hasOwnProperty(disk_add) && disks[disk_add].hasOwnProperty('partitions'))
        {
            var partitions = disks[disk_add]['partitions'] ;
            var last_partition = 0 ;
            var root_part = 0 ;

            for(var j in partitions)
            {
                last_partition = parseInt(j) ;

                if(disk_add == 0)
                {
                    if(partitions[j]['mpnt'] == '/') root_part = j ;
                }
                else
                {
                    root_part = 1 ;
                }
            }

            var part_add = last_partition + 1 ;

            partitions[part_add] = part_add_data ;
            if(partitions.hasOwnProperty(root_part) && partitions[root_part].hasOwnProperty('size')) partitions[root_part]['size'] = partitions[root_part]['size'] - part_size ;

            //var show_out = 'D: ' + disk_add + ' -> ' + root_part + ' -> ' + last_partition + ' -> ' + part_add ;
            //alert(show_out) ;

            disks[disk_add]['partitions'] = partitions ;
        }

        //var show_data_part = 'DISK: ' + disk + ' -> ' + part_mpnt + ' -> ' + part_type + ' -> ' + part_size ;
        //alert(show_data_part) ;
    }

    disks_data['disks'] = disks ;

    var disks_data_out = JSON.stringify(disks_data,null,9) ;

    //alert(disks_data_out) ;

    disks_data_out = urlsafe_b64encode(disks_data_out) ;

    get_vps_disks_seter(disks_data_out,id_part_data,id_disks_show,false) ;

    return result ;
}

function apply_changes_partitions(disks_data_in,id_part_data,id_disks_show,id_disks_seter,resize)
{
    var result = false ;

	var partitions_seter_modal_id_txt = 'modal_' + id_disks_show ;

	var disks_data = urlsafe_b64decode(disks_data_in) ;

	disks_data = JSON.parse(disks_data) ;

    var disks = disks_data['disks'] ;

    var disk_inputs = get_inputs_by_id_prefix_return_id_value('DISK_IN____') ;

    var disk = null ;
    var part = null ;

    if((disk_inputs != null) && (typeof(disk_inputs) == 'object'))
    {
        for(var i in disk_inputs)
        {
            var prefix_part = '' ;
            var key = i.split('_') ;

            if((key != null) && (typeof(key) == 'object'))
            {
                var last_key = key.length - 1 ;
                if(last_key >= 0)
                {
                    key = key[key.length - 1] ;
                }
                else
                {
                    key = '' ;
                }
            }
            else
            {
                key = '' ;
            }

            switch(key)
            {
                case "ADVANCED":
                    prefix_part = remove_suffix(i,'_' + key) ;
                    disk = get_disk_from_id_prefix(prefix_part) ;
                    var advanced = false ;
                    if(disk_inputs[i] == 1) advanced = true ;
                    if(disks.hasOwnProperty(disk))
                    {
                        disks[disk][key.toLowerCase()] = advanced ;
                    }
                    else
                    {

                    }
                break ;

                case "MPNT":
                case "TYPE":
                case "SIZE":
                    prefix_part = remove_suffix(i,'_' + key) ;
                    disk = get_disk_from_id_prefix(prefix_part) ;
                    part = get_part_from_id_prefix(prefix_part) ;
                    if(disks.hasOwnProperty(disk) && disks[disk].hasOwnProperty('partitions') && disks[disk]['partitions'].hasOwnProperty(part))
                    {
                        if(disks[disk]['partitions'][part].hasOwnProperty(key.toLowerCase())) disks[disk]['partitions'][part][key.toLowerCase()] = disk_inputs[i] ;
                    }
                    else
                    {
                        if(disks.hasOwnProperty(disk) && disks[disk].hasOwnProperty('default_fstype')) part_type = disks[disk]['default_fstype'] ;
                        var part_type = 'ext4' ;
                        var part_size = 1024 ;
                        var part_used = 0 ;
                        var part_mpnt = '' ;
                        var part_minsize = 0 ;
                        var part_porc_used = 0 ;
                        var part_uuid = '' ;

                        var part_add_data = new Object() ;

                        part_add_data['type'] = part_type ;
                        part_add_data['size'] = part_size ;
                        part_add_data['used'] = part_used ;
                        part_add_data['mpnt'] = part_mpnt ;
                        part_add_data['minsize'] = part_minsize ;
                        part_add_data['porc_used'] = part_porc_used ;
                        part_add_data['uuid'] = part_uuid ;

                        disks[disk]['partitions'][part] = part_add_data ;

                        if(disks[disk]['partitions'][part].hasOwnProperty(key.toLowerCase())) disks[disk]['partitions'][part][key.toLowerCase()] = disk_inputs[i] ;
                    }
                break ;
            }
        }

        disks_data['disks'] = disks ;
    }

    var disks_data_out = JSON.stringify(disks_data,null,9) ;

    disks_data_out = urlsafe_b64encode(disks_data_out) ;

    if(document.getElementById(id_part_data).value != disks_data_out)
    {
        document.getElementById(id_part_data).value = disks_data_out ;
    }

    document.getElementById(id_disks_seter).innerHTML = '' ;
    var show_data = get_vps_disks_show(disks_data_out,id_part_data,false,'disks',resize) ;

    //alert(id_disks_show + ' -> ' + id_disks_seter + ' -> \n\n' + show_data) ;
    document.getElementById(id_disks_show).innerHTML = show_data ;

    hide_modal('disks') ;

    update_height("vps-control-form") ;

    return result ;
}

function partitions_change_advanced(disks_data_in,id_part_data,id_disks_show,resize,disk,id_change_advanced)
{
    var result = false ;

    var disks_data = urlsafe_b64decode(disks_data_in) ;
    disks_data = JSON.parse(disks_data) ;

    var advanced = false ;
    if(document.getElementById(id_change_advanced).checked) advanced = true ;

    disks_data['disks'][disk]['advanced'] = advanced ;

    var disks_data_out = JSON.stringify(disks_data,null,9) ;
    disks_data_out = urlsafe_b64encode(disks_data_out) ;

    get_vps_disks_seter(disks_data_out,id_part_data,id_disks_show,resize) ;

    return result ;
}

function init_submit_set_vps(parms_in,prefix_form_vars,command)
{
    var result = true ;

    goto_top = true ;

    manage_vps_clear_timeout(true,false) ;

    proc_form(prefix_form_vars,command);

    return result ;
}

function resize_vps(parms_in,prefix_form_vars,command)
{
    var result = true ;

    goto_top = true ;

    manage_vps_clear_timeout() ;

    proc_form(prefix_form_vars,'resize');

    return result ;
}

function after_submit_set_vps(parms_in)
{
    var result = false ;

    var parms = urlsafe_b64decode(parms_in) ;

    parms = JSON.parse(parms) ;

    if((typeof(parms) == 'object') && (parms != null))
    {
        if(parms.hasOwnProperty('proc_function') && (typeof(parms['proc_function']) == 'string') && (parms['proc_function'].length > 0))
        {
            var proc_form_delay = 2500 ;
            if(parms.hasOwnProperty('proc_function_delay') && (typeof(parms['proc_function_delay']) == 'number')) proc_form_delay = parms['proc_function_delay'] ;

            if(parms.hasOwnProperty('proc_function_parms') && (typeof(parms['proc_function_parms']) == 'object') && (parms['proc_function_parms'] != null))
            {
                var next_parms = urlsafe_b64encode(JSON.stringify(parms['proc_function_parms'])) ;

                var next_function = 'after_submit_set_vps_webconsole("' + parms['proc_function'] + '","' + next_parms + '");' ;
                setTimeout(next_function,proc_form_delay) ;
            }
        }
    }

    return result ;
}

function webconsole_countdown_close(id_show_message,prev,prox)
{
  var result = false ;

  if(webconsole_count>0)
  {
    var show_in = document.getElementById(id_show_message) ;
    webconsole_count = webconsole_count - 1 ;
    var alert_message = "" + prev + " " + webconsole_count + " " + prox + "" ;
    show_in.innerHTML = alert_message ;
    var function_rec = "webconsole_countdown_close('"+id_show_message+"','"+prev+"','"+prox+"');" ;
    setTimeout(function_rec,1000) ;
  }
  else
  {
    webconsole_count = 0 ;

    var evt_detail = new Object() ;
    evt_detail['bubbles'] = true ;
    evt_detail['detail'] = null ;
    evt_detail['composed'] = true ;

    document.dispatchEvent(new CustomEvent('webconsole_disconnect',evt_detail));

    hide_modal('webconsole') ;
  }
  
  return result ;
}

function webconsole_disconnect_now()
{
  var result = false ;

  modal_blocked = false ;
  webconsole_count = 1 ;

  return result ;
}

function after_submit_set_vps_webconsole(command,parms_in)
{
  var result = false ;

  window.scrollTo(0,0) ;
  document.getElementsByTagName('body')[0].scrollTop = 0 ; 

  webconsole_count = 0 ;
  webconsole_proxy_data = false ;
  webconsole_desktopName = '' ;

  var parms = urlsafe_b64decode(parms_in) ;

  parms = JSON.parse(parms) ;

  if((parms != null) && (typeof(parms) == 'object'))
  {
    if(parms.hasOwnProperty('webconsole_proxy_data') && (typeof(parms['webconsole_proxy_data']) == 'string') && (parms['webconsole_proxy_data'].trim().length > 0))
    {
      webconsole_proxy_data = parms['webconsole_proxy_data'] ;
      webconsole_proxy_data = urlsafe_b64decode(webconsole_proxy_data) ;
      webconsole_proxy_data = JSON.parse(webconsole_proxy_data) ;
      delete parms['webconsole_proxy_data'] ;
    }
  }

  if(send_api_command(command,parms) || true)
  {
    var evt_detail = new Object() ;
    evt_detail['bubbles'] = true ;
    evt_detail['detail'] = urlsafe_b64encode(JSON.stringify(webconsole_proxy_data)) ;
    evt_detail['composed'] = true ;
    
    //alert(JSON.stringify(evt_detail,null,9)) ;
    var evt_evt = new CustomEvent('webconsole_connect',evt_detail) ;
    window.dispatchEvent(evt_evt) ;

    show_modal('webconsole',true) ;

    var prev = 'ALERT_CLOSE_WINDOW' ;
    var prox = 'SECONDS' ;

    if(show_messages.hasOwnProperty(prev)) prev = show_messages[prev] ;
    if(show_messages.hasOwnProperty(prox)) prox = show_messages[prox] ;

    webconsole_count = webconsole_proxy_data['websocket_proxy_timeout'] ;

    webconsole_countdown_close('webconsole_timeout_counter',prev,prox) ;
  }

  return result ;
}

function after_set_web_console(parms_in)
{
    var result = false ;

    var parms = urlsafe_b64decode(parms_in) ;

    parms = JSON.parse(parms) ;

    if((typeof(parms) == 'object') && (parms != null))
    {
        if(parms.hasOwnProperty('proc_function') && (typeof(parms['proc_function']) == 'string') && (parms['proc_function'].length > 0))
        {
            var proc_form_delay = 2500 ;
            if(parms.hasOwnProperty('proc_function_delay') && (typeof(parms['proc_function_delay']) == 'number')) proc_form_delay = parms['proc_function_delay'] ;

            if(parms.hasOwnProperty('proc_function_parms') && (typeof(parms['proc_function_parms']) == 'object') && (parms['proc_function_parms'] != null))
            {
                var next_parms = urlsafe_b64encode(JSON.stringify(parms['proc_function_parms'])) ;

                var next_function = 'after_submit_set_vps_webconsole("' + parms['proc_function'] + '","' + next_parms + '");' ;
                setTimeout(next_function,proc_form_delay) ;
            }
        }
    }

    return result ;
}

function webconsole_send_api_command_clk(command=null)
{
    document.getElementById('webconsole_action_buttons').innerHTML = get_webconsole_command_buttons(true,false,false) ;
    webconsole_send_api_command(command) ;
}

function webconsole_send_api_command(command_in=null)
{
    var do_show_loader = false ;
    var headers = null ;
    var params = null ;
    var id_name_for_div_content = null ;

    var command = null ;

    if((command_in != null) && (typeof(command_in) == 'string') && (command_in.length > 0))
    {
      command = urlsafe_b64decode(command_in) ;
      command = command.substring('webconsole_command_'.length) ;
    }

    //alert('ACA: ' + command_in + ' -> ' + command) ;

    headers = new Object() ;
    headers['Content-type'] = 'application/x-www-form-urlencoded' ;

    if(typeof(web_api_session_data) == "string")
    {
        if(web_api_session_data.length > 0)
        {
            if(!isNaN(web_api_session_id_expire))
            {
                var d = new Date() ;
                var t = d.getTime() ;
                t = t / 1000 ;
                t = Math.round(t) ;
                
                if(web_api_session_id_expire > t)
                {
                    headers['web_api_session_data'] = web_api_session_data ;
                    headers['web_api_session_id_expire'] = web_api_session_id_expire ;
                }
            }
        }
    }

    var id_vps_server = null ;

    if((webconsole_send_api_command_data != null) && (typeof(webconsole_send_api_command_data) == 'object') && webconsole_send_api_command_data.hasOwnProperty('id_vps_server') && (webconsole_send_api_command_data['id_vps_server'].length > 0))
    {
      id_vps_server = webconsole_send_api_command_data['id_vps_server'] ;
    }

    //alert(JSON.stringify(webconsole_send_api_command_data),null,9) ;
    if((id_vps_server != null) && (command != null))
    {
      params = new Object() ;
      params['id_vps_server'] = id_vps_server ;

      var success_callback = "webconsole_send_api_command_receive_ok" ;
      var error_callback = "webconsole_send_api_command_receive_error" ;

      if(command == 'manage-vps') success_callback = "webconsole_send_api_command_manage_vps_receive_ok" ;
      if(command == 'manage-vps-wr')
      {
        success_callback = "webconsole_send_api_command_manage_vps_wr_receive_ok" ;
        command = 'manage-vps' ;
      }

      if(command == 'manage-vps')
      {
        var only_vps_status = true ;
        params['only_vps_status'] = only_vps_status ;
        params['command_step'] = 0 ;
      }
      else
      {
        params['command_vps'] = command ;
        command = 'proc-commands-vps' ;
      }

      params['command'] = command ;
      params['command_args'] = urlsafe_b64encode(JSON.stringify(params)) ;

      //alert(command) ;

      do_post_request(api_end_point,headers,params,success_callback,error_callback,do_show_loader,id_name_for_div_content) ;
    }

}

function webconsole_send_api_command_receive_ok(data_in,id_name_for_div_content_in,params_in=null)
{
    var data = data_in ;
    
    if(typeof data == "object")
    {
        if(data.hasOwnProperty('error') && data['error'])
        {
            if(data.hasOwnProperty('errors'))
            {
                var errors = data['errors'] ;
                var err_msg = "<br/>\n" ;
                for(var key in errors)
                {
                    if(errors.hasOwnProperty(key))
                    {
                        var errors_key = errors[key] ;
                        if((typeof(show_error_codes) == 'object') && (show_error_codes != null) && show_error_codes.hasOwnProperty(errors_key))
                        {
                            err_msg = err_msg + show_error_codes[errors_key] + "<br/>\n" ;
                        }
                        else
                        {
                            err_msg = err_msg + errors_key + "<br/>\n" ;
                        }
                    }
                }
                
                err_msg = err_msg + "<br/>\n" ;
                show_alert_data(err_msg,'alert_error') ;
            }
        }
        else if(data.hasOwnProperty('result') && data['result'] && data.hasOwnProperty('data'))
        {
            //var show_msg_ok_af = "" ;
            //var show_msg_error_af = "" ;

            //var pending_command = true ;
            //var vps_on = false ;

            //webconsole_rfb_is_connected = false ;

            //document.getElementById('webconsole_action_buttons').innerHTML = get_webconsole_command_buttons(pending_command,vps_on) ;
        }
        else
        {
            show_alert_data('BAD_RESPONSE_FORMAT','alert_error') ;
            //api_data_receive_error("BAD_RESPONSE_FORMAT",id_name_for_div_content_in) ;
        }
    }
}

function webconsole_send_api_command_manage_vps_receive_ok(data_in,id_name_for_div_content_in,params_in=null)
{
    var data = data_in ;

    //alert('ACA:') ;
    
    if(typeof data == "object")
    {
        if(data.hasOwnProperty('error') && data['error'])
        {
            if(data.hasOwnProperty('errors'))
            {
                var errors = data['errors'] ;
                var err_msg = "<br/>\n" ;
                for(var key in errors)
                {
                    if(errors.hasOwnProperty(key))
                    {
                        var errors_key = errors[key] ;
                        if((typeof(show_error_codes) == 'object') && (show_error_codes != null) && show_error_codes.hasOwnProperty(errors_key))
                        {
                            err_msg = err_msg + show_error_codes[errors_key] + "<br/>\n" ;
                        }
                        else
                        {
                            err_msg = err_msg + errors_key + "<br/>\n" ;
                        }
                    }
                }
                
                err_msg = err_msg + "<br/>\n" ;
                show_alert_data(err_msg,'alert_error') ;
            }
        }
        else if(data.hasOwnProperty('result') && data['result'] && data.hasOwnProperty('data'))
        {
            var pending_command = true ;
            var vps_on = false ;
            var pending_command_cmd_out = null ;
            var show_ctrlaltdel = true ;

            if((data['data'] != null) && (typeof(data['data']) == 'object') && data['data'].hasOwnProperty('vps_status'))
            {
                if(data['data']['vps_status'].hasOwnProperty('vps_on')) vps_on = data['data']['vps_status']['vps_on'] ;

                if(data['data']['vps_status'].hasOwnProperty('pending_command')) pending_command = data['data']['vps_status']['pending_command'] ;

                if(pending_command)
                {
                    show_ctrlaltdel = false ;
                    if(data['data']['vps_status'].hasOwnProperty('pending_command_cmd') && (typeof(data['data']['vps_status']['pending_command_cmd']) == 'string'))
                    {
                        var pending_command_cmd = data['data']['vps_status']['pending_command_cmd'] ;
                        pending_command_cmd_out = pending_command_cmd.toUpperCase() + '_SHOW' ;
                        if(show_messages.hasOwnProperty(pending_command_cmd_out)) pending_command_cmd_out = show_messages[pending_command_cmd_out] ;
                        document.getElementById('webconsole_status').innerHTML = pending_command_cmd_out ;

                        var evt_detail = new Object() ;
                        evt_detail['bubbles'] = true ;
                        evt_detail['composed'] = true ;

                        if((pending_command_cmd == 'set_vps') || (pending_command_cmd == 'install'))
                        {
                            document.dispatchEvent(new CustomEvent('webconsole_rfb_view_only_true',evt_detail)) ;
                        }
                        else
                        {
                            document.dispatchEvent(new CustomEvent('webconsole_rfb_view_only_false',evt_detail)) ;
                        }
                    }
                }
                else
                {
                    var evt_detail = new Object() ;
                    evt_detail['bubbles'] = true ;
                    evt_detail['detail'] = pending_command ;
                    evt_detail['composed'] = true ;
                    document.dispatchEvent(new CustomEvent('webconsole_desktopname',evt_detail)) ;
                    document.dispatchEvent(new CustomEvent('webconsole_rfb_view_only_false',evt_detail)) ;
                }

                //alert(JSON.stringify(data['data']['vps_status'],null,9)) ;
            }

            document.getElementById('webconsole_action_buttons').innerHTML = get_webconsole_command_buttons(pending_command,vps_on,show_ctrlaltdel) ;

            var evt_detail = new Object() ;
            evt_detail['bubbles'] = true ;
            evt_detail['detail'] = '' ;
            evt_detail['composed'] = true ;

            //alert(JSON.stringify(evt_detail,null,9)) ;
            document.dispatchEvent(new CustomEvent('webconsole_resend_command',evt_detail)) ;
        }
        else
        {
            show_alert_data('BAD_RESPONSE_FORMAT','alert_error') ;
        }
    }
}

function webconsole_send_api_command_manage_vps_wr_receive_ok(data_in,id_name_for_div_content_in,params_in=null)
{
    var data = data_in ;

    //alert('ACA:') ;
    
    if(typeof data == "object")
    {
        if(data.hasOwnProperty('error') && data['error'])
        {
            if(data.hasOwnProperty('errors'))
            {
                var errors = data['errors'] ;
                var err_msg = "<br/>\n" ;
                for(var key in errors)
                {
                    if(errors.hasOwnProperty(key))
                    {
                        var errors_key = errors[key] ;
                        if((typeof(show_error_codes) == 'object') && (show_error_codes != null) && show_error_codes.hasOwnProperty(errors_key))
                        {
                            err_msg = err_msg + show_error_codes[errors_key] + "<br/>\n" ;
                        }
                        else
                        {
                            err_msg = err_msg + errors_key + "<br/>\n" ;
                        }
                    }
                }
                
                err_msg = err_msg + "<br/>\n" ;
                show_alert_data(err_msg,'alert_error') ;
            }
        }
        else if(data.hasOwnProperty('result') && data['result'] && data.hasOwnProperty('data'))
        {
            var pending_command = true ;
            var vps_on = true ;
            var pending_command_cmd_out = null ;

            if((data['data'] != null) && (typeof(data['data']) == 'object') && data['data'].hasOwnProperty('vps_status'))
            {
                if(data['data']['vps_status'].hasOwnProperty('vps_on')) vps_on = data['data']['vps_status']['vps_on'] ;
                if(data['data']['vps_status'].hasOwnProperty('pending_command')) pending_command = data['data']['vps_status']['pending_command'] ;

                if(pending_command)
                {
                    if(data['data']['vps_status'].hasOwnProperty('pending_command_cmd') && (typeof(data['data']['vps_status']['pending_command_cmd']) == 'string'))
                    {
                        var pending_command_cmd = data['data']['vps_status']['pending_command_cmd'] ;

                        pending_command_cmd_out = pending_command_cmd.toUpperCase() + '_SHOW' ;
                        if(show_messages.hasOwnProperty(pending_command_cmd_out)) pending_command_cmd_out = show_messages[pending_command_cmd_out] ;
                        document.getElementById('webconsole_status').innerHTML = pending_command_cmd_out ;

                        var evt_detail = new Object() ;
                        evt_detail['bubbles'] = true ;
                        evt_detail['composed'] = true ;

                        if((pending_command_cmd == 'set_vps') || (pending_command_cmd == 'install'))
                        {
                            document.dispatchEvent(new CustomEvent('webconsole_rfb_view_only_true',evt_detail)) ;
                        }
                        else
                        {
                            document.dispatchEvent(new CustomEvent('webconsole_rfb_view_only_false',evt_detail)) ;
                        }

                    }
                }
                else
                {
                    var evt_detail = new Object() ;
                    evt_detail['bubbles'] = true ;
                    evt_detail['detail'] = '' ;
                    evt_detail['composed'] = true ;
                    document.dispatchEvent(new CustomEvent('desktopname',evt_detail)) ;
                    document.dispatchEvent(new CustomEvent('webconsole_rfb_view_only_false',evt_detail)) ;
                }

                //alert(JSON.stringify(data['data']['vps_status'],null,9)) ;
            }

            document.getElementById('webconsole_action_buttons').innerHTML = get_webconsole_command_buttons(pending_command,vps_on,false) ;
        }
        else
        {
            show_alert_data('BAD_RESPONSE_FORMAT','alert_error') ;
        }
    }
}

function webconsole_send_api_command_receive_error(data,id_name_for_div_content,params_in=null)
{
    var out_msg = "ERROR: " + data ;
    
    show_alert_data(out_msg,'alert_error') ;
    
    return true ;
}

function webconsole_send_api_command_clear_timeout()
{
	if(webconsole_send_api_command_timeout != false)
	{
		clearTimeout(webconsole_send_api_command_timeout) ;
		webconsole_send_api_command_timeout = false ;
	}
}

function get_vps_stats_graph(stats_data_in)
{
    var stats_data = urlsafe_b64decode(stats_data_in) ;
    stats_data = JSON.parse(stats_data) ;

    var graph_img = null ;
    var stats_data_out = null ;

    if((stats_data != null) && (typeof(stats_data) == 'object') && stats_data.hasOwnProperty('graph_img'))
    {
        graph_img = stats_data['graph_img'] ;
    }

    put_vps_stats_graph(graph_img) ;

    var vps_name = '' ;
    if((stats_data != null) && (typeof(stats_data) == 'object') && stats_data.hasOwnProperty('vps_name')) vps_name = stats_data['vps_name'] ;

    if((stats_data != null) && (typeof(stats_data) == 'object') && stats_data.hasOwnProperty('stats_data')) get_vps_stats_tables(vps_name,stats_data['stats_data']) ;

    window.scrollTo(0,0) ;
    document.getElementsByTagName('body')[0].scrollTop = 0 ;

    update_height("vps-control-form") ;
}

function get_vps_stats_tables(vps_name_in,stats_data_in)
{
    var stats_data = urlsafe_b64decode(stats_data_in) ;
    stats_data = JSON.parse(stats_data) ;

    var vps_name = vps_name_in ;
    
    put_vps_stats_tables(vps_name,stats_data) ;
}

function after_resize_vps(parms_in)
{
    var result = false ;

    var parms = urlsafe_b64decode(parms_in) ;

    parms = JSON.parse(parms) ;

    if((typeof(parms) == 'object') && (parms != null))
    {
        if(parms.hasOwnProperty('proc_function') && (typeof(parms['proc_function']) == 'string') && (parms['proc_function'].length > 0))
        {
            var proc_form_delay = 2500 ;
            if(parms.hasOwnProperty('proc_function_delay') && (typeof(parms['proc_function_delay']) == 'number')) proc_form_delay = parms['proc_function_delay'] ;

            if(parms.hasOwnProperty('proc_function_parms') && (typeof(parms['proc_function_parms']) == 'object') && (parms['proc_function_parms'] != null))
            {
                var next_parms_aux = parms['proc_function_parms'] ;

                if(next_parms_aux.hasOwnProperty('goto_top'))
                {
                    window.scrollTo(0,0) ;
                    document.getElementsByTagName('body')[0].scrollTop = 0 ; 
                    delete next_parms_aux['goto_top'] ;
                }

                var next_parms = urlsafe_b64encode(JSON.stringify(next_parms_aux)) ;

                var next_function = 'after_resize_vps_aux("' + parms['proc_function'] + '","' + next_parms + '");' ;
                setTimeout(next_function,proc_form_delay) ;
            }
        }
    }

    return result ;
}

function after_resize_vps_aux(command,next_parms_in)
{
    var next_parms = JSON.parse(urlsafe_b64decode(next_parms_in)) ;

    send_api_command(command,next_parms) ;

}

function after_purchase_vps(parms_in)
{
    var result = false ;

    var parms = urlsafe_b64decode(parms_in) ;

    parms = JSON.parse(parms) ;

    if((typeof(parms) == 'object') && (parms != null))
    {
        if(parms.hasOwnProperty('proc_function') && (typeof(parms['proc_function']) == 'string') && (parms['proc_function'].length > 0))
        {
            var proc_form_delay = 2500 ;
            if(parms.hasOwnProperty('proc_function_delay') && (typeof(parms['proc_function_delay']) == 'number')) proc_form_delay = parms['proc_function_delay'] ;

            if(parms.hasOwnProperty('proc_function_parms') && (typeof(parms['proc_function_parms']) == 'object') && (parms['proc_function_parms'] != null))
            {
                var next_parms_aux = parms['proc_function_parms'] ;

                if(next_parms_aux.hasOwnProperty('checkbox_var'))
                {
                    var checkbox_var = next_parms_aux['checkbox_var'] ;
                    delete next_parms_aux['checkbox_var'] ;

                    var checkbox_var_message = next_parms_aux['checkbox_var_message'] ;
                    delete next_parms_aux['checkbox_var_message'] ;

                    var period = get_input_select_by_name('period').value ;
                    next_parms_aux['period'] = period ;

                    if(get_input_select_by_name(checkbox_var).checked)
                    {
                        if(next_parms_aux.hasOwnProperty('goto_top'))
                        {
                            window.scrollTo(0,0) ;
                            document.getElementsByTagName('body')[0].scrollTop = 0 ; 
                            delete next_parms_aux['goto_top'] ;
                        }

                        show_modal('loader',true) ;

                        var next_parms = urlsafe_b64encode(JSON.stringify(next_parms_aux)) ;
                        var next_function = 'after_resize_vps_aux("' + parms['proc_function'] + '","' + next_parms + '");' ;
                        setTimeout(next_function,proc_form_delay) ;
                    }
                    else
                    {
                        show_terms_and_conditions(checkbox_var_message) ;
                    }
                }
                else
                {
                    if(next_parms_aux.hasOwnProperty('goto_top'))
                    {
                        window.scrollTo(0,0) ;
                        document.getElementsByTagName('body')[0].scrollTop = 0 ; 
                        delete next_parms_aux['goto_top'] ;
                    }

                    show_modal('loader',true) ;

                    var period = get_input_select_by_name('period').value ;
                    next_parms_aux['period'] = period ;

                    var next_parms = urlsafe_b64encode(JSON.stringify(next_parms_aux)) ;
                    var next_function = 'after_resize_vps_aux("' + parms['proc_function'] + '","' + next_parms + '");' ;
                    setTimeout(next_function,proc_form_delay) ;
                }
            }
        }
    }

    return result ;
}

function on_change_var_key_change_var_value(parms_in)
{
    var result = false ;

    var parms = urlsafe_b64decode(parms_in) ;

    parms = JSON.parse(parms) ;

    if((typeof(parms) == 'object') && (parms != null))
    {
        if(parms.hasOwnProperty('var_key') && (typeof(parms['var_key']) == 'string') && (parms['var_key'].length > 0) && parms.hasOwnProperty('var_value') && (typeof(parms['var_value']) == 'string') && (parms['var_value'].length > 0))
        {
            var name_key = parms['var_key'] ;
            var name_value = parms['var_value'] ;

            var index_key = get_input_select_by_name(name_key) ;
            //index_key = index_key.value.toString().trim() ;
            index_key = index_key.value ;

            if(parms.hasOwnProperty('var_change_data') && (typeof(parms['var_change_data']) == 'object') && parms['var_change_data'].hasOwnProperty(index_key))
            {
                var index_value = get_input_select_by_name(name_value) ;
                index_value.value = parms['var_change_data'][index_key] ;
            }
        }
    }

    return result ;
}

function set_goto_top()
{
    window.scrollTo(0,0) ;
    document.getElementsByTagName('body')[0].scrollTop = 0 ; 
    //goto_top = true ;

    return true ;
}

function reload_on_change_lang_newrec()
{
    var current_href = window.location.href ;
    var current_get_parms = get_get_inputs(true) ;
    var next_href = window.location.href ;

    var value_elem_change = 'en_US' ;
    var id_elem_change = get_input_select_by_name('language') ;

    if(id_elem_change !== false)
    {
        value_elem_change = id_elem_change.value ;
    }

    if((typeof(current_get_parms) == 'object') && (current_get_parms != null))
    {
        current_get_parms['lang'] = value_elem_change ;
    }
    else
    {
        current_get_parms = new Object() ;
        current_get_parms['lang'] = value_elem_change ;
    }

    var out_parms = '' ;

    for(var key in current_get_parms)
    {
        if(out_parms.length == 0)
        {
            out_parms = out_parms + '?' ;
        }
        else
        {
            out_parms = out_parms + '&' ;
        }

        if(key == 'lang')
        {
            out_parms = out_parms + key + '=' + value_elem_change ;
        }
        else
        {
            out_parms = out_parms + key + '=' + current_get_parms[key] ;
        }
    }

    next_href = next_href + out_parms ;
    window.location.href = next_href ;

    return true ;
}

function goto_pay()
{
    var result = false ;

    var node_pay_id = get_node_id_from_node_name(menu_struct,'pay') ;
    if(node_pay_id !== null) manage_control_menu(node_pay_id) ;

    return result ;
}